#include "jboci.h"

int CheckFormatInOracle(char *sqlstmt,char *value,char *format,char *new_value)
{
  OCIStmt *stmtp;
  OCIBind *bndhp1=NULL,*bndhp2=NULL,*bndhp3=NULL;
  ub2 ind1=-1;

  if (!ora_connected)
  {
    //WPrintf("\nNot connected to a database");
    WPrintf("Not connected to a database");
    return -1;
  }
  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErr(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               sqlstmt,
                               strlen(sqlstmt),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -2;
  }
  if (ChkOCIErr(OCIBindByName(stmtp,
                             &bndhp1,
                             g_oci->errhp,
                             ":new_value",
                             strlen(":new_value"),
                             new_value,
                             999,
                             SQLT_STR,
                             &ind1,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -3;
  }
  if (ChkOCIErr(OCIBindByName(stmtp,
                             &bndhp2,
                             g_oci->errhp,
                             ":value",
                             strlen(":value"),
                             value,
                             strlen(value)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -4;
  }
  if (format)
  {
    if (ChkOCIErr(OCIBindByName(stmtp,
                               &bndhp3,
                               g_oci->errhp,
                               ":format",
                               strlen(":format"),
                               format,
                               strlen(format)+1,
                               SQLT_STR,
                               NULL,
                               NULL,
                               NULL,
                               0,
                               NULL,
                               OCI_DEFAULT)))
    {
      OCIHandleFree(stmtp,OCI_HTYPE_STMT);
      return -5;
    }
  }
  if (ChkOCIErr(OCIStmtExecute(g_oci->svchp,
                               stmtp,
                               g_oci->errhp,
                               1,
                               0,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -6;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  if (ind1==-1)
    new_value[0]='\0';
  return 0;
}


int CheckVariableFormat(VariableType vt,char *format,char *value)
{
  char new_value[1000]="";
  int ret=0;

  if (vt==V_NUMBER)
  {
    if (format==NULL)
      ret=CheckFormatInOracle("begin :new_value:=to_char(to_number(:value)); end;",value,NULL,new_value);
    else
      ret=CheckFormatInOracle("begin :new_value:=to_char(to_number(:value,:format)); end;",value,format,new_value);
  }
  else if (vt==V_DATE)
  {
    if (format==NULL)
      ret=CheckFormatInOracle("begin :new_value:=to_char(to_date(:value)); :new_value:=:value; end;",value,NULL,new_value);
    else
      ret=CheckFormatInOracle("begin :new_value:=to_char(to_date(:value,:format)); :new_value:=:value; end;",value,format,new_value);
  }
  strcpy(value,new_value);
  return ret;
}