#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "jboci.h"

int ora_connected=0;
OCIEnvironment *g_oci=NULL;
char connectstring[MAX_PATH]="",g_database[250]="";

void ComposeConnectString(char *username,char *password,char *database,char *connect_as)
{
  if (username[0]=='\0' && password[0]=='\0')
    strcpy(connectstring,"/");
  else
  {
    strcpy(connectstring,username);
    strcat(connectstring,"/");
    strcat(connectstring,password);
  }
  if (database[0]!='\0')
  {
    strcat(connectstring,"@");
    strcat(connectstring,database);
  }
  if (connect_as[0]!='\0')
  {
    strcat(connectstring," as ");
    strcat(connectstring,connect_as);
  }
}

int CheckOCIError(sword status,char *file,int line,int show,ub4 ignore_code,HWND hWnd)
{
  text errbuf[512];
  ub4 errcode;
  ub2 offset;

  switch (status)
  {
    case OCI_SUCCESS:
      return 0;
      break;
    case OCI_SUCCESS_WITH_INFO:
      OCIErrorGet(g_oci->errhp, 
            1, 
            NULL, 
            &errcode,
            errbuf, 
            sizeof(errbuf), 
            OCI_HTYPE_ERROR);
      if (show==1)
      {
        if (errcode==24344)
          WPrintf("\rThere are compilation errors\n");
        else
          WPrintf("\rSuccess with warnings, ORA-%-05d\n",errcode);
      }
      else if (show==2)
      {
        if (errcode==24344)
          AnalyzeError("There are compilation errors");
        else
          AnalyzeError("Success with warnings, ORA-%-05d",errcode);
      }
      else if (show==3)
      {
        if (errcode==24344)
          SchemaPrintf(hWnd,"There are compilation errors");
        else
          SchemaPrintf(hWnd,"Success with warnings, ORA-%-05d",errcode);
      }
      return 0;
      break;
    case OCI_NEED_DATA:
      if (show==1)
        WPrintf("\rError - OCI_NEED_DATA (%s, line %d)\n",file,line);
      else if (show==2)
        AnalyzeError("Error - OCI_NEED_DATA (%s, line %d)",file,line);
      else if (show==3)
        SchemaPrintf(hWnd,"Error - OCI_NEED_DATA (%s, line %d)",file,line);
      break;
    case OCI_NO_DATA:
/*      if (show==1)
        WPrintf("\rError - OCI_NODATA (%s, line %d)\n",file,line);
      else if (show==2)
        AnalyzeError("Error - OCI_NODATA (%s, line %d)",file,line);
      else if (show==3)
        SchemaPrintf(hWnd,"Error - OCI_NODATA (%s, line %d)",file,line);
      break;*/
    case OCI_ERROR:
      if (g_oci->errhp!=NULL)
      {
        OCIErrorGet(g_oci->errhp, 
                    1, 
                    NULL, 
                    &errcode,
                    errbuf, 
                    sizeof(errbuf), 
                    OCI_HTYPE_ERROR);
        if (ignore_code==errcode)
          return 0;
        if (g_oci->offset)
        {
          g_oci->offset=0;
          if (!ChkOCIErr(OCIAttrGet(g_oci->stmtp, 
                                    OCI_HTYPE_STMT, 
                                    &offset, 
                                    NULL, 
                                    OCI_ATTR_PARSE_ERROR_OFFSET, 
                                    g_oci->errhp)))
          {
            PrintErrorCharacter(offset);
          }
        }
        if (show==1)
          WPrintf("\r%s\n", errbuf);
        else if (show==2)
          AnalyzeError("%s", errbuf);
        else if (show==3)
          SchemaPrintf(hWnd,"%s", errbuf);
      }
      else
      {
        if (show==1)
          WPrintf("Error - OCI_ERROR (%s, line %d)\n",file,line);
        if (show==2)
          AnalyzeError("Error - OCI_ERROR (%s, line %d)",file,line);
        if (show==3)
          SchemaPrintf(hWnd,"Error - OCI_ERROR (%s, line %d)",file,line);
      }
      break;
    case OCI_INVALID_HANDLE:
      if (show==1)
        WPrintf("Error - OCI_INVALID_HANDLE (%s, line %d)\n",file,line);
      else if (show==2)
        AnalyzeError("Error - OCI_INVALID_HANDLE (%s, line %d)",file,line);
      else if (show==3)
        SchemaPrintf(hWnd,"Error - OCI_INVALID_HANDLE (%s, line %d)",file,line);
      break;
    case OCI_STILL_EXECUTING:
      if (show==1)
        WPrintf("Error - OCI_STILL_EXECUTE (%s, line %d)\n",file,line);
      else if (show==2)
        AnalyzeError("Error - OCI_STILL_EXECUTE (%s, line %d)\n",file,line);
      else if (show==3)
        SchemaPrintf(hWnd,"Error - OCI_STILL_EXECUTE (%s, line %d)\n",file,line);
      break;
    default:
      break;
  }
  return 1;
}


int InitOCI(void)
{
  g_oci=malloc(sizeof(OCIEnvironment));
  if (g_oci==NULL)
    return -1;
  memset(g_oci,0,sizeof(OCIEnvironment));

/*  if (ChkOCIErr(OCIEnvCreate(&g_oci->envhp,
                             OCI_THREADED|OCI_OBJECT,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL)))
  {
    return -1;
  }
*/
  if (ChkOCIErr(OCIInitialize(OCI_THREADED|OCI_OBJECT, 
                              NULL,
                              NULL,
                              NULL,
                              NULL)))
  {
    return -1;
  }

  if (ChkOCIErr(OCIEnvInit(&g_oci->envhp, 
                           OCI_DEFAULT, 
                           0,
                           NULL)))
  {
    return -1;
  }

  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->srvhp,
                               OCI_HTYPE_SERVER, 
                               0, 
                               NULL)))
  {
    return -2;
  }

  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->errhp,
                               OCI_HTYPE_ERROR, 
                               0, 
                               NULL)))
  {
    return -3;
  }

  return 0;
}

int ConnectToOracle(char *username,char *password,char *database,char *connect_as)
{
  char buffer[512],new_database[512],host[50],port[10],sid[10];
  ub4 mode,credentials;

  if (ora_connected)
    DisconnectFromOracle();

  if (connect_as==NULL || connect_as[0]=='\0')
    mode=OCI_DEFAULT;
  else if (!_stricmp(connect_as,"normal"))
    mode=OCI_DEFAULT;
  else if (!_stricmp(connect_as,"sysoper"))
    mode=OCI_SYSOPER;
  else if (!_stricmp(connect_as,"sysdba"))
    mode=OCI_SYSDBA;
  else
  {
    WPrintf("Invalid connect mode %s\n",connect_as);
    return 1;
  }

  if (!strchr(database,':'))
    strcpy(new_database,database);
  else
  {
    switch (sscanf(database,"%[^:]:%[^:]:%s",host,port,sid))
    {
      case 3:
        sprintf(new_database,"(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%s)))(CONNECT_DATA=(SID=%s)))",host,port,sid);
        break;
      case 2:
        if (atoi(port)==0)
          sprintf(new_database,"(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=1521)))(CONNECT_DATA=(SID=%s)))",host,port);
        else
          sprintf(new_database,"(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%s)))(CONNECT_DATA=(SID=ORCL)))",host,port);
        break;
      default:
        strcpy(new_database,database);
        break;
    }
  }
  if (ChkOCIErr(OCIServerAttach(g_oci->srvhp,
                                g_oci->errhp,
                                new_database,
                                strlen(new_database),
                                OCI_DEFAULT)))
  {
    return -1;
  }

  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->svchp,
                               OCI_HTYPE_SVCCTX, 
                               0, 
                               NULL)))
  {
    OCIServerDetach(g_oci->srvhp,
                    g_oci->errhp,
                    OCI_DEFAULT);
    return -2;
  }

  if (ChkOCIErr(OCIAttrSet(g_oci->svchp, 
                           OCI_HTYPE_SVCCTX, 
                           g_oci->srvhp, 
                           0, 
                           OCI_ATTR_SERVER, 
                           g_oci->errhp)))
  {
    OCIServerDetach(g_oci->srvhp,
                    g_oci->errhp,
                    OCI_DEFAULT);
    OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
    g_oci->svchp=NULL;
    return -3;
  }

  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->usrhp,
                               OCI_HTYPE_SESSION, 
                               0, 
                               NULL)))
  {
    OCIServerDetach(g_oci->srvhp,
                    g_oci->errhp,
                    OCI_DEFAULT);
    OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
    g_oci->svchp=NULL;
    return -4;
  }
  if (strcmp(username,"/") && (int)strlen(password)>0)
  {
    if (ChkOCIErr(OCIAttrSet(g_oci->usrhp, 
                             OCI_HTYPE_SESSION,
                             username, 
                             strlen(username),
                             OCI_ATTR_USERNAME, 
                             g_oci->errhp)))
    {
      OCIServerDetach(g_oci->srvhp,
                      g_oci->errhp,
                      OCI_DEFAULT);
      OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
      g_oci->svchp=NULL;
      OCIHandleFree(g_oci->usrhp,OCI_HTYPE_SESSION);
      g_oci->usrhp=NULL;
      return -5;
    }

    if (ChkOCIErr(OCIAttrSet(g_oci->usrhp, 
                             OCI_HTYPE_SESSION,
                             password, 
                             strlen(password),
                             OCI_ATTR_PASSWORD, 
                             g_oci->errhp)))
    {
      OCIServerDetach(g_oci->srvhp,
                      g_oci->errhp,
                      OCI_DEFAULT);
      OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
      g_oci->svchp=NULL;
      OCIHandleFree(g_oci->usrhp,OCI_HTYPE_SESSION);
      g_oci->usrhp=NULL;
      return -6;
    }
    credentials=OCI_CRED_RDBMS;
  }
  else
  {
    credentials=OCI_CRED_EXT;
  }
  if (ChkOCIErr(OCISessionBegin(g_oci->svchp, 
                                g_oci->errhp, 
                                g_oci->usrhp,
                                credentials, 
                                mode)))
  {
    OCIServerDetach(g_oci->srvhp,
                    g_oci->errhp,
                    OCI_DEFAULT);
    OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
    g_oci->svchp=NULL;
    OCIHandleFree(g_oci->usrhp,OCI_HTYPE_SESSION);
    g_oci->usrhp=NULL;
    return -7;
  }
  if (ChkOCIErr(OCIAttrSet(g_oci->svchp, 
                           OCI_HTYPE_SVCCTX, 
                           g_oci->usrhp, 
                           0,
                           OCI_ATTR_SESSION, 
                           g_oci->errhp)))
  {
    OCISessionEnd(g_oci->svchp,
                  g_oci->errhp,
                  g_oci->usrhp,
                  OCI_DEFAULT);
    OCIServerDetach(g_oci->srvhp,
                    g_oci->errhp,
                    OCI_DEFAULT);
    OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
    g_oci->svchp=NULL;
    OCIHandleFree(g_oci->usrhp,OCI_HTYPE_SESSION);
    g_oci->usrhp=NULL;
    return -7;
  }
  ora_connected=1;
  if (!ChkOCIErr(OCIServerVersion (g_oci->svchp, 
                                   g_oci->errhp,
                                   buffer,
                                   512,
                                   OCI_HTYPE_SVCCTX)))
  {
    WPrintf("\rConnected to:\n%s\n",buffer);
  }
  else
    WPrintf("\rConnected\n");
  strcpy(g_database,database);
  SetWindowTitle(username,database);
  SaveUserCredentials(username,database);
  ComposeConnectString(username,password,database,connect_as);
  return 0;
}

int DisconnectFromOracle(void)
{
  OCISessionEnd(g_oci->svchp,
                g_oci->errhp,
                g_oci->usrhp,
                OCI_DEFAULT);
  OCIServerDetach(g_oci->srvhp,
                  g_oci->errhp,
                  OCI_DEFAULT);
  OCIHandleFree(g_oci->svchp,OCI_HTYPE_SVCCTX);
  g_oci->svchp=NULL;
  OCIHandleFree(g_oci->usrhp,OCI_HTYPE_SESSION);
  g_oci->usrhp=NULL;
  ora_connected=0;
  SetWindowTitle("","");
  OCIHandleFree(g_oci->envhp,OCI_HTYPE_SESSION);
  OCIHandleFree(g_oci->errhp,OCI_HTYPE_SESSION);
  OCIHandleFree(g_oci->srvhp,OCI_HTYPE_SESSION);

  InitOCI();
  return 0;
}

int ConnectWithConnectString(char *connectstring)
{
  char *tmp,*tmp2;
  char username[100]="",password[100]="",database[100]="",connect_as[20]="";
  char **argv;
  int argc,x;

  ConvertCommandLine(connectstring,&argc,&argv);
  tmp=strchr(argv[0],'/');
  if (tmp!=NULL)
  {
    *tmp='\0';
    strncpy(username,argv[0],100);
    if (username[0]=='\0')
      strncpy(username,"/",100);
    tmp2=tmp;
    tmp2++;
    tmp=strchr(tmp2,'@');
    if (tmp!=NULL)
    {
      *tmp='\0';
      strncpy(password,tmp2,100);
      tmp2=tmp;
      tmp2++;
      strncpy(database,tmp2,100);
    }
    else
    {
      strncpy(password,tmp2,100);
    }
  }
  else
  {
    tmp=strchr(argv[0],'@');
    if (tmp!=NULL)
    {
      *tmp='\0';
      strncpy(username,argv[0],100);
      if (username[0]=='\0')
        strcpy(username,"/");
      tmp++;
      strncpy(database,tmp,100);
    }
    else
    {
      strncpy(username,argv[0],100);
    }
  }
  if (argc==3)
  {
    if (!_stricmp(argv[1],"as"))
    {
      strncpy(connect_as,argv[2],20);
    }
    else
      return 1;
  }
  for (x=0;x<argc;x++)
    free(argv[x]);
  free(argv);
  if (_stricmp(username,"internal") && _stricmp(username,"/") && password[0]=='\0')
  {
    WPrintf("Enter password: ");
    WScanf(g_text,password,1);
  }
  return ConnectToOracle(username,password,database,connect_as);
}
