#include "jboci.h"

void FillHintListFromQuery(TextWidget *text,char *query,char *name,char *owner,char *object_type)
{
  char *char_ptr=NULL;
  int len=200,result;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  ub4 qrows;
  int nrows,x;
  char query_finished=0;
  ub4 total_qrows=0;
  int fetch_array_size=SCHEMA_ARRAY_SIZE;

  if (ChkOCIErrN(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return;
  }
  if (ChkOCIErrN(OCIStmtPrepare(g_oci->stmtp,
                               g_oci->errhp,
                               query,
                               strlen(query),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }
  if (ChkOCIErrN(OCIBindByPos(g_oci->stmtp,
                             &bndhp,
                             g_oci->errhp,
                             1,
                             name,
                             strlen(name),
                             SQLT_CHR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }
  if (owner!=NULL)
  {
    if (ChkOCIErrN(OCIBindByPos(g_oci->stmtp,
                               &bndhp,
                               g_oci->errhp,
                               2,
                               owner,
                               strlen(owner),
                               SQLT_CHR,
                               NULL,
                               NULL,
                               NULL,
                               0,
                               NULL,
                               OCI_DEFAULT)))
    {
      OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
      g_oci->stmtp=NULL;
      return;
    }
    if (object_type!=NULL)
    {
      if (ChkOCIErrN(OCIBindByPos(g_oci->stmtp,
                                 &bndhp,
                                 g_oci->errhp,
                                 3,
                                 object_type,
                                 strlen(object_type),
                                 SQLT_CHR,
                                 NULL,
                                 NULL,
                                 NULL,
                                 0,
                                 NULL,
                                 OCI_DEFAULT)))
      {
        OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
        g_oci->stmtp=NULL;
        return;
      }
    }
  }
  char_ptr=(char*)malloc(SCHEMA_ARRAY_SIZE*len*sizeof(char));
  if (char_ptr==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  if (ChkOCIErrN(OCIDefineByPos(g_oci->stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               char_ptr,
                               len,
                               SQLT_STR,
                               NULL,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    free(char_ptr);
    return;
  }

  g_oci->offset=1;
  result=OCIStmtExecute(g_oci->svchp,
                        g_oci->stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT);
  if (result!=OCI_SUCCESS && result!=OCI_NO_DATA)
  {
    g_oci->offset=0;
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    free(char_ptr);
    return;
  }
  while (!query_finished)
  {
    result=OCIStmtFetch(g_oci->stmtp,
                        g_oci->errhp,
                        fetch_array_size,
                        OCI_FETCH_NEXT,
                        OCI_DEFAULT);
    if (result!=OCI_SUCCESS && result!=OCI_NO_DATA && result!=OCI_SUCCESS_WITH_INFO)
    {
      if (ChkOCIErrI(result,1406))
        break;
    }
    if (ChkOCIErrN(OCIAttrGet(g_oci->stmtp,
                             OCI_HTYPE_STMT, 
                             &qrows,
                             NULL,
                             OCI_ATTR_ROW_COUNT, 
                             g_oci->errhp)))
    {
      break;
    } 
    nrows = qrows - total_qrows;
    if (nrows!=fetch_array_size)
      query_finished=1;

    for (x=0;x<(int)(qrows-total_qrows);x++)
    {
      AddToHintList(text,&char_ptr[x*len]);
    }
    total_qrows = qrows;
  }
  g_oci->offset=0;
  OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
  g_oci->stmtp=NULL;
  free(char_ptr);
}
