#include "jboci.h"

int ProcessIndexColumns(HWND hWnd,char *schema,char *index)
{
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;
  char *columnstr="select COLUMN_NAME from all_ind_columns where index_owner=:p_schema and index_name=:p_index order by column_position";
  char column_name[4001]="";
  ub2 column_name_i;
  int n,result;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               columnstr,
                               strlen(columnstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_index",
                             strlen("p_index"),
                             index,
                             strlen(index)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               column_name,
                               sizeof(column_name),
                               SQLT_STR,
                               &column_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  n=0;
  for (;;)
  {
    result=OCIStmtFetch(stmtp,
                        g_oci->errhp,
                        1,
                        OCI_FETCH_NEXT,
                        OCI_DEFAULT);
    if (result!=OCI_SUCCESS && result!=OCI_NO_DATA && result!=OCI_SUCCESS_WITH_INFO)
    {
      break;
    }
    if (result==OCI_NO_DATA)
      break;
    if (n)
      SchemaPrintf(hWnd," ,\"%s\"",column_name);
    else
      SchemaPrintf(hWnd,"  \"%s\"",column_name);
    SchemaPrintf(hWnd,"\n");
    n++;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  return 0;
}

int ProcessIndex(HWND hWnd,char *schema,char *index)
{
  char *tablestr="select INDEX_TYPE,UNIQUENESS,TABLESPACE_NAME,INI_TRANS,MAX_TRANS,INITIAL_EXTENT,NEXT_EXTENT,MIN_EXTENTS,MAX_EXTENTS,PCT_INCREASE,PCT_THRESHOLD,FREELISTS,FREELIST_GROUPS,PCT_FREE,TABLE_NAME from all_indexes where owner=:p_schema and index_name=:p_index";
  char index_type[28],uniqueness[10],tablespace_name[31]="",table_name[31]="";
  unsigned int ini_trans,max_trans,initial_extent,next_extent,min_extents,max_extents,pct_increase,pct_threshold,freelists,freelist_groups,pct_free,table_name_i;
  ub2 index_type_i=-1,uniqueness_i=-1,tablespace_name_i=-1,ini_trans_i=-1,max_trans_i=-1,initial_extent_i=-1,next_extent_i=-1,min_extents_i=-1,max_extents_i=-1,pct_increase_i=-1,pct_threshold_i=-1,freelists_i=-1,freelist_groups_i=-1,pct_free_i=-1;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               tablestr,
                               strlen(tablestr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_index",
                             strlen("p_index"),
                             index,
                             strlen(index)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               index_type,
                               sizeof(index_type),
                               SQLT_STR,
                               &index_type_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               uniqueness,
                               sizeof(uniqueness),
                               SQLT_STR,
                               &uniqueness_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               tablespace_name,
                               sizeof(tablespace_name),
                               SQLT_STR,
                               &tablespace_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               4,
                               &ini_trans,
                               sizeof(ini_trans),
                               SQLT_UIN,
                               &ini_trans_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               5,
                               &max_trans,
                               sizeof(max_trans),
                               SQLT_UIN,
                               &max_trans_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               6,
                               &initial_extent,
                               sizeof(initial_extent),
                               SQLT_UIN,
                               &initial_extent_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               7,
                               &next_extent,
                               sizeof(next_extent),
                               SQLT_UIN,
                               &next_extent_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               8,
                               &min_extents,
                               sizeof(min_extents),
                               SQLT_UIN,
                               &min_extents_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               9,
                               &max_extents,
                               sizeof(max_extents),
                               SQLT_UIN,
                               &max_extents_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               10,
                               &pct_increase,
                               sizeof(pct_increase),
                               SQLT_UIN,
                               &pct_increase_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               11,
                               &pct_threshold,
                               sizeof(pct_threshold),
                               SQLT_UIN,
                               &pct_threshold_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               12,
                               &freelists,
                               sizeof(freelists),
                               SQLT_UIN,
                               &freelists_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               13,
                               &freelist_groups,
                               sizeof(freelist_groups),
                               SQLT_UIN,
                               &freelist_groups_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               14,
                               &pct_free,
                               sizeof(pct_free),
                               SQLT_UIN,
                               &pct_free_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               15,
                               &table_name,
                               sizeof(table_name),
                               SQLT_STR,
                               &table_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  SchemaPrintf(hWnd,"CREATE");
  if (index_type_i!=(ub2)-1 && (!strcmp(index_type,"BITMAP") || !strcmp(index_type,"BITMAP/REV")))
    SchemaPrintf(hWnd," BITMAP");
  if (uniqueness_i!=(ub2)-1 && !strcmp(uniqueness,"UNIQUE"))
    SchemaPrintf(hWnd," UNIQUE");
  SchemaPrintf(hWnd," INDEX \"%s\" on \"%s\" (\n",index,table_name);

  /* Create columns */
  if (ProcessIndexColumns(hWnd,schema,index)!=0)
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  SchemaPrintf(hWnd,")\n");
  if (tablespace_name_i!=(ub2)-1)
    SchemaPrintf(hWnd,"TABLESPACE \"%s\"\n",tablespace_name);
  if (pct_free_i!=(ub2)-1)
    SchemaPrintf(hWnd,"PCTFREE %u\n",pct_free);
  if (ini_trans_i!=(ub2)-1)
    SchemaPrintf(hWnd,"INITRANS %u\n",ini_trans);
  if (max_trans_i!=(ub2)-1)
    SchemaPrintf(hWnd,"MAXTRANS %u\n",max_trans);
  if (initial_extent_i!=(ub2)-1 ||
      next_extent_i!=(ub2)-1 ||
      min_extents_i!=(ub2)-1 ||
      max_extents_i!=(ub2)-1 ||
      pct_increase_i!=(ub2)-1 ||
      freelists_i!=(ub2)-1 ||
      freelist_groups_i!=(ub2)-1)
  {     
    SchemaPrintf(hWnd,"STORAGE (\n");
    if (initial_extent_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         INITIAL %u\n",initial_extent);
    if (next_extent_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         NEXT %u\n",next_extent);
    if (min_extents_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         MINEXTENTS %u\n",min_extents);
    if (max_extents_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         MAXEXTENTS %u\n",max_extents);
    if (pct_increase_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         PCTINCREASE %u\n",pct_increase);
    if (freelists_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         FREELISTS %u\n",freelists);
    if (freelist_groups_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         FREELIST GROUPS %u\n",freelist_groups);
    SchemaPrintf(hWnd,"        )\n");
  }
  if (index_type_i!=(ub2)-1 && (!strcmp(index_type,"BITMAP") || !strcmp(index_type,"BITMAP/REV") || !strcmp(index_type,"NORMAL/REV")))
    SchemaPrintf(hWnd,"REVERSE\n");
  SchemaPrintf(hWnd,"/\n\n");
  return 0;
}

