#include "jboci.h"

int ProcessTrigger(HWND hWnd,char *schema,char *trigger)
{
  char *triggerstr="select TRIGGER_BODY,DESCRIPTION from all_triggers where owner=:p_schema and trigger_name=:p_trigger";
  char trigger_body[32000]="",description[4001];
  ub2 trigger_body_i=-1,description_i=-1;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               triggerstr,
                               strlen(triggerstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_trigger",
                             strlen("p_trigger"),
                             trigger,
                             strlen(trigger)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               &trigger_body,
                               sizeof(trigger_body),
                               SQLT_STR,
                               &trigger_body_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               &description,
                               sizeof(description),
                               SQLT_STR,
                               &description_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;

  SchemaPrintf(hWnd,"CREATE OR REPLACE TRIGGER %s",description);
  if (description[strlen(description)-1]!='\n')
    SchemaPrintf(hWnd,"\n");
  SchemaPrintf(hWnd,"%s",trigger_body);
  if (trigger_body[strlen(trigger_body)-1]!='\n')
    SchemaPrintf(hWnd,"\n");
  SchemaPrintf(hWnd,"/\n");
  SchemaPrintf(hWnd,"show err\n");

  return 0;
}