#include "jboci.h"

int PrintServerOutput(TextWidget *text)
{
  char sqlstr[]="begin dbms_output.get_line(:1,:2); end;";
  OCIStmt *stmtp;
  OCIBind *bndhp=NULL;
  char line[256];
  int status;
  ub2 ind1,ind2;

  if (!ora_connected)
  {
//    WPrintf("\nNot connected to a database");
    WPrintf("Not connected to a database");
    return -1;
  }
  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErr(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               sqlstr,
                               strlen(sqlstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -2;
  }
  if (ChkOCIErr(OCIBindByPos(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             1,
                             line,
                             255,
                             SQLT_STR,
                             &ind1,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -2;
  }
  if (ChkOCIErr(OCIBindByPos(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             2,
                             &status,
                             sizeof(int),
                             SQLT_INT,
                             &ind2,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -2;
  }
  for (;;)
  {
    if (ChkOCIErr(OCIStmtExecute(g_oci->svchp,
                                 stmtp,
                                 g_oci->errhp,
                                 1,
                                 0,
                                 NULL,
                                 NULL,
                                 OCI_DEFAULT)))
    {
      OCIHandleFree(stmtp,OCI_HTYPE_STMT);
      return -2;
    }
    if (status!=0)
      break;
    line[255]='\0';
    WPrintf("%s\n",line);
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  return 0;
}
