#include "jboci.h"

void GetStatistics(SessionStatistic **s,int *ns)
{
  char char_ptr[65];
  int len=65,result;
  int statistic,value;
  char sql_stmt[]="select s.statistic#,s.value,n.name from v$statname n,v$sesstat s where s.statistic#=n.statistic# and sid=(select sid from v$session where audsid=userenv('sessionid')) and n.statistic# in (7,38,39,40,44,182,183,184,188,189) order by 1";
  OCIDefine *defhp=NULL;
  char_ptr[0]='\0';

  *ns=0;
  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &g_oci->stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return;
  }
  if (ChkOCIErr(OCIStmtPrepare(g_oci->stmtp,
                               g_oci->errhp,
                               sql_stmt,
                               strlen(sql_stmt),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }
  if (ChkOCIErr(OCIDefineByPos(g_oci->stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               &statistic,
                               sizeof(int),
                               SQLT_INT,
                               NULL,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }

  if (ChkOCIErr(OCIDefineByPos(g_oci->stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               &value,
                               sizeof(int),
                               SQLT_INT,
                               NULL,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }

  if (ChkOCIErr(OCIDefineByPos(g_oci->stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               char_ptr,
                               len,
                               SQLT_STR,
                               NULL,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    return;
  }

  g_oci->offset=0;
  result=OCIStmtExecute(g_oci->svchp,
                        g_oci->stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT);
  if (result!=OCI_SUCCESS && result!=OCI_NO_DATA)
  {
    g_oci->offset=0;
    OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
    g_oci->stmtp=NULL;
    WPrintf("Failed to get session statistics, check that you have enabled the PLUSTRACE role\n");
    return;
  }
  *s=NULL;
  for (;;)
  {
    result=OCIStmtFetch(g_oci->stmtp,
                        g_oci->errhp,
                        1,
                        OCI_FETCH_NEXT,
                        OCI_DEFAULT);
    if (result!=OCI_SUCCESS && result!=OCI_NO_DATA && result!=OCI_SUCCESS_WITH_INFO)
    {
      break;
    }
    if (result==OCI_NO_DATA)
      break;
    *s=(SessionStatistic*)realloc((void*)*s,(*ns+1)*sizeof(SessionStatistic));
    (*s)[*ns].statistic=statistic;
    (*s)[*ns].value=value;
    strcpy((*s)[*ns].name,char_ptr);
    (*ns)++;
  }
  g_oci->offset=0;
  OCIHandleFree(g_oci->stmtp,OCI_HTYPE_STMT);
  g_oci->stmtp=NULL;
}

void ShowStatistics(TextWidget *text)
{
  SessionStatistic *s;
  int ns,x;

  if (text->npre_stats)
  {
    GetStatistics(&s,&ns);
    WPrintf("Statistics\n");
    WPrintf("------------------------------------------------\n");
    for (x=0;x<ns;x++)
    {
      WPrintf("%10d %s\n",s[x].value-text->pre_stats[x].value,s[x].name);
    }
    free(text->pre_stats);
    text->pre_stats=NULL;
    text->npre_stats=0;
  }
}