#include "jbsql.h"

Option default_options[]={
  {"allow_newline", (char*)   0,         0, IDI_NEWLINE,      1, O_BOOLEAN, "Allow newline typing",   "If set, pressing Enter inside a sql statement inserts a newline. If not set, then the statement is executed.",NULL},
  {"arraysize",     (char*)1000,         0, 0,                0, O_INT,     "",                       "How many records are fetched at once?",NULL},
  {"autocomplete",  (char*)   1,         0, IDI_AUTOCOMPLETE, 0, O_BOOLEAN, "Autocomplete",           "Should autocomplete be active when you press TAB?",NULL},
  {"autotrace",     (char*)   0,         0, IDI_AUTOTRACE,    0, O_BOOLEAN, "Autotrace",              "When autotrace is enabled, the execution plan is displayed in the sql analyzer window",NULL},
  {"commandhistory",(char*)100,          0, 0,                0, O_INT,     "",                       "How many previous commands are kept in memory?",NULL},
  {"debug",         (char*)   0,         0, IDI_DEBUG,        0, O_BOOLEAN, "Turn debug on",          "If set, debug information is written to jbsql.log",NULL},
  {"directory",     ".",          MAX_PATH, 0,                0, O_DIR,     "",                       "What is the startup directory?",NULL},
  {"editor",        "notepad.exe",MAX_PATH, 0,                0, O_CHAR,    "",                       "Specifies what editor to use with the 'edit' command",NULL},
  {"edit_filename", "afiedt.buf", MAX_PATH, 0,                0, O_CHAR,    "",                       "Specifies what filename to create with the 'edit' command",NULL},
  {"feedback",      (char*)   1,         0, IDI_FEEDBACK,     0, O_BOOLEAN, "Show Feedback",          "If set, then a result is shown each time a statement is successfully processed",NULL},
  {"heading",       (char*)   1,         0, IDI_HEADING,      0, O_BOOLEAN, "Show Headers",           "Should headings be printed when output to screen is enabled or spooling is on?",NULL},
  {"history",       (char*)   1,         0, IDI_HISTORY,      0, O_BOOLEAN, "Keep history",           "Keep a history of all executed statements",NULL},
  {"listview",      (char*)   1,         0, IDI_LISTVIEW,     0, O_BOOLEAN, "Show results in list",   "Should query output appear in the listview table at the bottom?",NULL},
  {"long",          (char*)4000,         0, 0,                0, O_INT,     "",                       "The size queries from LONG, LONG RAW, BLOB, CLOB and BFILE colums",NULL},
  {"max_scripts",   (char*)20,           0, 0,                0, O_INT,     "",                       "How many nested scripts are allowed?",NULL},
  {"maxlines",      (char*)1000,         0, 0,                0, O_INT,     "",                       "How many lines are buffered in the console window?",NULL},
  {"maxmem",        (char*)10485760,     0, 0,                0, O_INT,     "",                       "The maximum memory usage for queries, if array_size*record_size > maximum_memory then the arraysize is automatically adjusted to fit into the maximum memory usage",NULL},
  {"prompt",        "SQL>",             20, 0,                0, O_CHAR,    "",                       "The console prompt",NULL},
  {"savehistory",   (char*)   1,         0, IDI_SAVEHISTORY,  0, O_BOOLEAN, "Save history",           "Saves the command history to a file when you exit jbsql and reads them back in when you start jbsql",NULL},
  {"scan",          (char*)   1,         0, IDI_SCAN,         0, O_BOOLEAN, "Scan scripts",           "Scan scripts for & characters and ask for replacements",NULL},
  {"screen",        (char*)   0,         0, IDI_SCREEN,       1, O_BOOLEAN, "Output to screen",       "Is output from queries to the console on?",NULL},
  {"serveroutput",  (char*)   1,         0, IDI_SERVEROUTPUT, 1, O_BOOLEAN, "Show server output",     "Displays output generated by dbms_output",EnableServerOutput},
  {"sound",         (char*)   1,         0, IDI_SOUND,        1, O_BOOLEAN, "Make a sound",           "Make a sound when long running statements are finished",NULL},
  {"soundfile",     "ringin.wav", MAX_PATH, 0,                0, O_CHAR,    "The wav file",           "Specifies the WAV file to play when a long running statement has finished",NULL},
  {"soundtime",     (char*)  60,         0, 0,                0, O_INT,     "The time of a statement","The number of seconds a statement must be running and after which a sound should be played",NULL},
  {"timing",        (char*)   1,         0, IDI_TIMING,       0, O_BOOLEAN, "Show timing",            "If enabled, displays elapsed time information for each sql statement",NULL},
  {"verify",        (char*)   1,         0, IDI_VERIFY,       0, O_BOOLEAN, "Verify user input",      "If enabled, displays old and new values for replaced && variables in a script",NULL},
};
